Page({
  data: {
    db: null,
    dbinsertid: 0
  },
  // 事件处理函数
  getOpenId() {
    wx.cloud.callFunction({
      name: 'quickstartFunctions',
      config: {
        env: 'cloud1-1g6tbtz5bf2b4c8c'
      },
      data: {
        type: 'getOpenId'
      }
    })
    .then((resp) => {
      console.log(resp)
    }).catch((e) => {
      console.error(e);
    });
  },
  onLoad() {
    wx.cloud.init({
      // env 参数说明：
      //   env 参数决定接下来小程序发起的云开发调用（wx.cloud.xxx）会默认请求到哪个云环境的资源
      //   此处请填入环境 ID, 环境 ID 可打开云控制台查看
      //   如不填则使用默认环境（第一个创建的环境）
      env: 'cloud1-1g6tbtz5bf2b4c8c',
      // traceUser: true,
      // url: 'http://127.0.0.1:7001',
      appid: 'xxx',
      secret: 'xxx',
      // accessToken: 'xxx'
    });
    this.setData({
      db: wx.cloud.database()
    })
  },

  dbquery() {
    this.data.db.collection('sales').doc('fc8e64656412858004b2c4a405b31be4').get({
    // this.data.db.collection('sales').doc(this.data.dbinsertid).get({
      success: function (res) {
        // data:
        //   city: "山西"
        //   region: "太原"
        //   sales: 1
        //   _id: "b8db217664100ee900004c0b40b35511"
        //   _openid: "ox5605MvcYnkAPG4mieKpd3fiocY"
        // errMsg: "document.get:ok"
        console.log(res)
      },
      fail: function (err) {
        console.error(err)
      }
    })
  },

  dbquerymore() {
    this.data.db.collection('sales').where({
      city: "山西"
    }).get({
      // this.data.db.collection('sales').doc(this.data.dbinsertid).get({
        success: function (res) {
          // data:
          //   city: "山西"
          //   region: "太原"
          //   sales: 1
          //   _id: "b8db217664100ee900004c0b40b35511"
          //   _openid: "ox5605MvcYnkAPG4mieKpd3fiocY"
          // errMsg: "document.get:ok"
          console.log(res)
        }
      })
  },

  dbinsert() {
    const that = this;
    this.data.db.collection('sales').add({
      data: {
        city: "山西",
        region: "太原",
        sales: 1,
        progress: 10
      },
      success: function(res) {
        // res 是一个对象，其中有 _id 字段标记刚创建的记录的 id
        // errMsg: "collection.add:ok"
        // _id: "3ddbc57c640fce860000c97d7e3744a8"
        console.log(res)
        that.setData({
          dbinsertid: res._id
        })
      },
      fail: function (err) {
        console.error(err)
      }
    })
  },

  dbupdate() {
    const _ = this.data.db.command
    this.data.db.collection('sales').doc("04b9d9a96412874000053cd44d069b81").update({
      data: {
        a: "123",
        b: 456
      },
      success: function(res) {
        // errMsg: "document.update:ok"
        // stats:
        //   updated: 0
        console.log(res)
      }
    })
  },

  dbdelete() {
    this.data.db.collection('sales').doc('04b9d9a96412874000053cd44d069b81').remove({
      success: function(res) {
        console.log(res)
      },
      fail: function (err) {
        console.error(err)
      }
    })
    // this.data.db.collection('sales').where({
    //   city: "山西"
    // }).remove({
    //   success: function(res) {
    //     console.log(res)
    //   },
    //   fail: function (err) {
    //     console.error(err)
    //   }
    // })
  },
  dbcommand() {
    const _ = this.data.db.command
    this.data.db.collection('sales').where({
      // gt 方法用于指定一个 "大于" 条件，此处 _.gt(30) 是一个 "大于 30" 的条件
      // progress: _.gt(25).and(_.lt(15))
    })
    .get({
      success: function(res) {
        console.log(res)
      }
    })
  },
  dbaggregation() {
    const abc = this.data.db.command.aggregate
    this.data.db.collection('sales').aggregate()
      .group({
        // 按 category 字段分组
        _id: '$city',
        // 让输出的每组记录有一个 avgSales 字段，其值是组内所有记录的 sales 字段的平均值
        avgSales: abc.avg('$sales')
      })
      .end()
      .then((res) => {
        console.log(res, '===')
      })
  },

  storageupdate() {
    wx.chooseMedia({
      count: 1,
      mediaType: ['image'],
      sourceType: ['album'],
      maxDuration: 30,
      camera: 'back',
      success(res) {
        const filePath = res.tempFiles[0].tempFilePath
        wx.cloud.uploadFile({
          filePath: filePath,
          cloudPath: 'example.png', // 上传至云端的路径
          success: res => {
            // errMsg: "cloud.uploadFile:ok"
            // fileID: "cloud://cloud1-1g6tbtz5bf2b4c8c.636c-cloud1-1g6tbtz5bf2b4c8c-1317030557/example.png"
            // statusCode: 204
            console.log(res)
          },
          fail: console.error
        })
      }
    })
  },
  storagedow() {
    wx.cloud.downloadFile({
      fileID: 'cloud://cloud1-1g6tbtz5bf2b4c8c.636c-cloud1-1g6tbtz5bf2b4c8c-1317030557/example.png',
      success: res => {
        // cookies: []
        // dataLength: 3297051
        // errMsg: "downloadFile:ok"
        // header: {Content-Type: "image/png", Date: "Wed, 15 Mar 2023 06:09:23 GMT", ETag: ""62664f43936f4fb166af6a4ed87d4190"", Server: "tencent-cos", x-cos-hash-crc64ecma: "3767981673397122649", …}
        // statusCode: 200
        // tempFilePath: "http://tmp/pScooPjNaooh62664f43936f4fb166af6a4ed87d4190.png"
        console.log(res)
      },
      fail: console.error
    })
  },
  storagedel() {
    wx.cloud.deleteFile({
      fileList: ['cloud://cloud1-1g6tbtz5bf2b4c8c.636c-cloud1-1g6tbtz5bf2b4c8c-1317030557/test3.png'],
      success: res => {
        // errMsg: "cloud.deleteFile:ok"
        // fileList: Array(1)
        //   0:
        //   errMsg: "STORAGE_EXCEED_AUTHORITY"
        //   fileID: "cloud://cloud1-1g6tbtz5bf2b4c8c.636c-cloud1-1g6tbtz5bf2b4c8c-1317030557/example.png"
        //   status: 1
        console.log(res)
      },
      fail: console.error
    })
  },
  storagetmpfiles() {
    wx.cloud.getTempFileURL({
    fileList: [{
      fileID: 'cloud://cloud1-1g6tbtz5bf2b4c8c.636c-cloud1-1g6tbtz5bf2b4c8c-1317030557/example.png',
      maxAge: 60 * 60, // one hour
    }],
    success: res => {
      // get temp file URL
      console.log(res)
    },
    fail: err => {
      // handle error
    }
  })

  }
})